'******************************************************************************
' Copyright (c) 2010 - 2014 Dave Hein
' See end of file for terms of use.
'******************************************************************************
OBJ
  c : "clibsd"

CON
  ENUMERRORS = 11

DAT
  unknown_error       byte "Unknown error", 0
  no_such_file        byte "No such file or directory", 0
  not_enough_memory   byte "Not enough memory", 0
  file_exists         byte "File exists", 0
  invalid_arg         byte "Invalid argument", 0
  io_error            byte "I/O error", 0
  not_directory       byte "Not a directory", 0
  is_directory        byte "Is a directory", 0
  directory_not_empty byte "Directory not empty", 0
  name_too_long       byte "Name too long", 0
  permission_denied   byte "Permission denied", 0

  _sys_errlist long @unknown_error, @no_such_file, @not_enough_memory
  long @file_exists, @invalid_arg, @io_error, @not_directory, @is_directory
  long @directory_not_empty, @name_too_long, @permission_denied

PUB strerror(errnum)
  if (errnum < 0 OR errnum => ENUMERRORS)
    errnum := 0
  return @@_sys_errlist[errnum]

PUB perror(ptr)
  c.printf2(string("%s: %s\n"), ptr, strerror(c.geterrno))

{{
+--------------------------------------------------------------------
|  TERMS OF USE: MIT License
+--------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, sublicense, and/or sell copies of the Software,
and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+------------------------------------------------------------------
}}
